## shadow 4.15.2

=== tests/tests/unit/Makefile ===
# Makefile.in generated by automake 1.16.5 from Makefile.am.
# tests/unit/Makefile.  Generated from Makefile.in by configure.

# Copyright (C) 1994-2021 Free Software Foundation, Inc.

# This Makefile.in is free software; the Free Software Foundation
# gives unlimited permission to copy and/or distribute it,
# with or without modifications, as long as this notice is preserved.

# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY, to the extent permitted by law; without
# even the implied warranty of MERCHANTABILITY or FITNESS FOR A
# PARTICULAR PURPOSE.



am__is_gnu_make = { \
  if test -z '$(MAKELEVEL)'; then \
    false; \
  elif test -n '$(MAKE_HOST)'; then \
    true; \
  elif test -n '$(MAKE_VERSION)' && test -n '$(CURDIR)'; then \
    true; \
  else \
    false; \
  fi; \
}
am__make_running_with_option = \
  case $${target_option-} in \
      ?) ;; \
      *) echo "am__make_running_with_option: internal error: invalid" \
              "target option '$${target_option-}' specified" >&2; \
         exit 1;; \
  esac; \
  has_opt=no; \
  sane_makeflags=$$MAKEFLAGS; \
  if $(am__is_gnu_make); then \
    sane_makeflags=$$MFLAGS; \
  else \
    case $$MAKEFLAGS in \
      *\\[\ \	]*) \
        bs=\\; \
        sane_makeflags=`printf '%s\n' "$$MAKEFLAGS" \
          | sed "s/$$bs$$bs[$$bs $$bs	]*//g"`;; \
    esac; \
  fi; \
  skip_next=no; \
  strip_trailopt () \
  { \
    flg=`printf '%s\n' "$$flg" | sed "s/$$1.*$$//"`; \
  }; \
  for flg in $$sane_makeflags; do \
    test $$skip_next = yes && { skip_next=no; continue; }; \
    case $$flg in \
      *=*|--*) continue;; \
        -*I) strip_trailopt 'I'; skip_next=yes;; \
      -*I?*) strip_trailopt 'I';; \
        -*O) strip_trailopt 'O'; skip_next=yes;; \
      -*O?*) strip_trailopt 'O';; \
        -*l) strip_trailopt 'l'; skip_next=yes;; \
      -*l?*) strip_trailopt 'l';; \
      -[dEDm]) skip_next=yes;; \
      -[JT]) skip_next=yes;; \
    esac; \
    case $$flg in \
      *$$target_option*) has_opt=yes; break;; \
    esac; \
  done; \
  test $$has_opt = yes
am__make_dryrun = (target_option=n; $(am__make_running_with_option))
am__make_keepgoing = (target_option=k; $(am__make_running_with_option))
pkgdatadir = $(datadir)/shadow
pkgincludedir = $(includedir)/shadow
pkglibdir = $(libdir)/shadow
pkglibexecdir = $(libexecdir)/shadow
am__cd = CDPATH="$${ZSH_VERSION+.}$(PATH_SEPARATOR)" && cd
install_sh_DATA = $(install_sh) -c -m 644
install_sh_PROGRAM = $(install_sh) -c
install_sh_SCRIPT = $(install_sh) -c
INSTALL_HEADER = $(INSTALL_DATA)
transform = $(program_transform_name)
NORMAL_INSTALL = :
PRE_INSTALL = :
POST_INSTALL = :
NORMAL_UNINSTALL = :
PRE_UNINSTALL = :
POST_UNINSTALL = :
build_triplet = x86_64-pc-linux-gnu
host_triplet = x86_64-pc-linux-gnu
check_PROGRAMS = test_adds$(EXEEXT) \
	test_atoi_strtoi$(EXEEXT) \
	test_chkname$(EXEEXT) test_sprintf$(EXEEXT) \
	test_strncpy$(EXEEXT) test_strtcpy$(EXEEXT) \
	test_xasprintf$(EXEEXT) \
	test_zustr2stp$(EXEEXT) $(am__EXEEXT_1)
am__append_1 = \
    test_logind

subdir = tests/unit
ACLOCAL_M4 = $(top_srcdir)/aclocal.m4
am__aclocal_m4_deps = $(top_srcdir)/m4/gettext.m4 \
	$(top_srcdir)/m4/iconv.m4 $(top_srcdir)/m4/intlmacosx.m4 \
	$(top_srcdir)/m4/lib-ld.m4 $(top_srcdir)/m4/lib-link.m4 \
	$(top_srcdir)/m4/lib-prefix.m4 $(top_srcdir)/m4/libtool.m4 \
	$(top_srcdir)/m4/ltoptions.m4 $(top_srcdir)/m4/ltsugar.m4 \
	$(top_srcdir)/m4/ltversion.m4 $(top_srcdir)/m4/lt~obsolete.m4 \
	$(top_srcdir)/m4/nls.m4 $(top_srcdir)/m4/po.m4 \
	$(top_srcdir)/m4/progtest.m4 $(top_srcdir)/acinclude.m4 \
	$(top_srcdir)/configure.ac
am__configure_deps = $(am__aclocal_m4_deps) $(CONFIGURE_DEPENDENCIES) \
	$(ACLOCAL_M4)
DIST_COMMON = $(srcdir)/Makefile.am $(am__DIST_COMMON)
mkinstalldirs = $(install_sh) -d
CONFIG_HEADER = $(top_builddir)/config.h
CONFIG_CLEAN_FILES =
CONFIG_CLEAN_VPATH_FILES =
am__EXEEXT_1 =  \
	test_logind$(EXEEXT)
am__test_adds_SOURCES_DIST = ../../lib/adds.c test_adds.c
am__dirstamp = $(am__leading_dot)dirstamp
am_test_adds_OBJECTS =  \
	../../lib/test_adds-adds.$(OBJEXT) \
	test_adds-test_adds.$(OBJEXT)
test_adds_OBJECTS = $(am_test_adds_OBJECTS)
am__DEPENDENCIES_1 =
test_adds_DEPENDENCIES = $(am__DEPENDENCIES_1)
AM_V_lt = $(am__v_lt_$(V))
am__v_lt_ = $(am__v_lt_$(AM_DEFAULT_VERBOSITY))
am__v_lt_0 = --silent
am__v_lt_1 = 
test_adds_LINK = $(LIBTOOL) $(AM_V_lt) --tag=CC $(AM_LIBTOOLFLAGS) \
	$(LIBTOOLFLAGS) --mode=link $(CCLD) $(test_adds_CFLAGS) \
	$(CFLAGS) $(test_adds_LDFLAGS) $(LDFLAGS) -o $@
am__test_atoi_strtoi_SOURCES_DIST = ../../lib/atoi/strtoi.c \
	test_atoi_strtoi.c
am_test_atoi_strtoi_OBJECTS = ../../lib/atoi/test_atoi_strtoi-strtoi.$(OBJEXT) \
	test_atoi_strtoi-test_atoi_strtoi.$(OBJEXT)
test_atoi_strtoi_OBJECTS = $(am_test_atoi_strtoi_OBJECTS)
test_atoi_strtoi_DEPENDENCIES =  \
	$(am__DEPENDENCIES_1)
test_atoi_strtoi_LINK = $(LIBTOOL) $(AM_V_lt) --tag=CC \
	$(AM_LIBTOOLFLAGS) $(LIBTOOLFLAGS) --mode=link $(CCLD) \
	$(test_atoi_strtoi_CFLAGS) $(CFLAGS) \
	$(test_atoi_strtoi_LDFLAGS) $(LDFLAGS) -o $@
am__test_chkname_SOURCES_DIST = ../../lib/chkname.c test_chkname.c
am_test_chkname_OBJECTS =  \
	../../lib/test_chkname-chkname.$(OBJEXT) \
	test_chkname-test_chkname.$(OBJEXT)
test_chkname_OBJECTS = $(am_test_chkname_OBJECTS)
test_chkname_DEPENDENCIES = $(am__DEPENDENCIES_1)
test_chkname_LINK = $(LIBTOOL) $(AM_V_lt) --tag=CC $(AM_LIBTOOLFLAGS) \
	$(LIBTOOLFLAGS) --mode=link $(CCLD) $(test_chkname_CFLAGS) \
	$(CFLAGS) $(test_chkname_LDFLAGS) $(LDFLAGS) -o $@
am__test_logind_SOURCES_DIST = ../../lib/logind.c test_logind.c
am_test_logind_OBJECTS =  \
	../../lib/test_logind-logind.$(OBJEXT) \
	test_logind-test_logind.$(OBJEXT)
test_logind_OBJECTS = $(am_test_logind_OBJECTS)
test_logind_DEPENDENCIES = $(am__DEPENDENCIES_1) \
	$(am__DEPENDENCIES_1)
test_logind_LINK = $(LIBTOOL) $(AM_V_lt) --tag=CC $(AM_LIBTOOLFLAGS) \
	$(LIBTOOLFLAGS) --mode=link $(CCLD) $(test_logind_CFLAGS) \
	$(CFLAGS) $(test_logind_LDFLAGS) $(LDFLAGS) -o $@
am__test_sprintf_SOURCES_DIST = ../../lib/string/sprintf.c \
	test_sprintf.c
am_test_sprintf_OBJECTS = ../../lib/string/test_sprintf-sprintf.$(OBJEXT) \
	test_sprintf-test_sprintf.$(OBJEXT)
test_sprintf_OBJECTS = $(am_test_sprintf_OBJECTS)
test_sprintf_DEPENDENCIES = $(am__DEPENDENCIES_1)
test_sprintf_LINK = $(LIBTOOL) $(AM_V_lt) --tag=CC $(AM_LIBTOOLFLAGS) \
	$(LIBTOOLFLAGS) --mode=link $(CCLD) $(test_sprintf_CFLAGS) \
	$(CFLAGS) $(test_sprintf_LDFLAGS) $(LDFLAGS) -o $@
am__test_strncpy_SOURCES_DIST = test_strncpy.c
am_test_strncpy_OBJECTS =  \
	test_strncpy-test_strncpy.$(OBJEXT)
test_strncpy_OBJECTS = $(am_test_strncpy_OBJECTS)
test_strncpy_DEPENDENCIES = $(am__DEPENDENCIES_1)
test_strncpy_LINK = $(LIBTOOL) $(AM_V_lt) --tag=CC $(AM_LIBTOOLFLAGS) \
	$(LIBTOOLFLAGS) --mode=link $(CCLD) $(test_strncpy_CFLAGS) \
	$(CFLAGS) $(test_strncpy_LDFLAGS) $(LDFLAGS) -o $@
am__test_strtcpy_SOURCES_DIST = ../../lib/string/strtcpy.c \
	test_strtcpy.c
am_test_strtcpy_OBJECTS = ../../lib/string/test_strtcpy-strtcpy.$(OBJEXT) \
	test_strtcpy-test_strtcpy.$(OBJEXT)
test_strtcpy_OBJECTS = $(am_test_strtcpy_OBJECTS)
test_strtcpy_DEPENDENCIES = $(am__DEPENDENCIES_1)
test_strtcpy_LINK = $(LIBTOOL) $(AM_V_lt) --tag=CC $(AM_LIBTOOLFLAGS) \
	$(LIBTOOLFLAGS) --mode=link $(CCLD) $(test_strtcpy_CFLAGS) \
	$(CFLAGS) $(test_strtcpy_LDFLAGS) $(LDFLAGS) -o $@
am__test_xasprintf_SOURCES_DIST = ../../lib/string/sprintf.c \
	test_xasprintf.c
am_test_xasprintf_OBJECTS = ../../lib/string/test_xasprintf-sprintf.$(OBJEXT) \
	test_xasprintf-test_xasprintf.$(OBJEXT)
test_xasprintf_OBJECTS = $(am_test_xasprintf_OBJECTS)
test_xasprintf_DEPENDENCIES = $(am__DEPENDENCIES_1)
test_xasprintf_LINK = $(LIBTOOL) $(AM_V_lt) --tag=CC \
	$(AM_LIBTOOLFLAGS) $(LIBTOOLFLAGS) --mode=link $(CCLD) \
	$(test_xasprintf_CFLAGS) $(CFLAGS) $(test_xasprintf_LDFLAGS) \
	$(LDFLAGS) -o $@
am__test_zustr2stp_SOURCES_DIST = test_zustr2stp.c
am_test_zustr2stp_OBJECTS =  \
	test_zustr2stp-test_zustr2stp.$(OBJEXT)
test_zustr2stp_OBJECTS = $(am_test_zustr2stp_OBJECTS)
test_zustr2stp_DEPENDENCIES = $(am__DEPENDENCIES_1)
test_zustr2stp_LINK = $(LIBTOOL) $(AM_V_lt) --tag=CC \
	$(AM_LIBTOOLFLAGS) $(LIBTOOLFLAGS) --mode=link $(CCLD) \
	$(test_zustr2stp_CFLAGS) $(CFLAGS) $(test_zustr2stp_LDFLAGS) \
	$(LDFLAGS) -o $@
AM_V_P = $(am__v_P_$(V))
am__v_P_ = $(am__v_P_$(AM_DEFAULT_VERBOSITY))
am__v_P_0 = false
am__v_P_1 = :
AM_V_GEN = $(am__v_GEN_$(V))
am__v_GEN_ = $(am__v_GEN_$(AM_DEFAULT_VERBOSITY))
am__v_GEN_0 = @echo "  GEN     " $@;
am__v_GEN_1 = 
AM_V_at = $(am__v_at_$(V))
am__v_at_ = $(am__v_at_$(AM_DEFAULT_VERBOSITY))
am__v_at_0 = @
am__v_at_1 = 
DEFAULT_INCLUDES = -I. -I$(top_builddir)
depcomp = $(SHELL) $(top_srcdir)/depcomp
am__maybe_remake_depfiles = depfiles
am__depfiles_remade = ../../lib/$(DEPDIR)/test_adds-adds.Po \
	../../lib/$(DEPDIR)/test_chkname-chkname.Po \
	../../lib/$(DEPDIR)/test_logind-logind.Po \
	../../lib/atoi/$(DEPDIR)/test_atoi_strtoi-strtoi.Po \
	../../lib/string/$(DEPDIR)/test_sprintf-sprintf.Po \
	../../lib/string/$(DEPDIR)/test_strtcpy-strtcpy.Po \
	../../lib/string/$(DEPDIR)/test_xasprintf-sprintf.Po \
	./$(DEPDIR)/test_adds-test_adds.Po \
	./$(DEPDIR)/test_atoi_strtoi-test_atoi_strtoi.Po \
	./$(DEPDIR)/test_chkname-test_chkname.Po \
	./$(DEPDIR)/test_logind-test_logind.Po \
	./$(DEPDIR)/test_sprintf-test_sprintf.Po \
	./$(DEPDIR)/test_strncpy-test_strncpy.Po \
	./$(DEPDIR)/test_strtcpy-test_strtcpy.Po \
	./$(DEPDIR)/test_xasprintf-test_xasprintf.Po \
	./$(DEPDIR)/test_zustr2stp-test_zustr2stp.Po
am__mv = mv -f
COMPILE = $(CC) $(DEFS) $(DEFAULT_INCLUDES) $(INCLUDES) $(AM_CPPFLAGS) \
	$(CPPFLAGS) $(AM_CFLAGS) $(CFLAGS)
LTCOMPILE = $(LIBTOOL) $(AM_V_lt) --tag=CC $(AM_LIBTOOLFLAGS) \
	$(LIBTOOLFLAGS) --mode=compile $(CC) $(DEFS) \
	$(DEFAULT_INCLUDES) $(INCLUDES) $(AM_CPPFLAGS) $(CPPFLAGS) \
	$(AM_CFLAGS) $(CFLAGS)
AM_V_CC = $(am__v_CC_$(V))
am__v_CC_ = $(am__v_CC_$(AM_DEFAULT_VERBOSITY))
am__v_CC_0 = @echo "  CC      " $@;
am__v_CC_1 = 
CCLD = $(CC)
LINK = $(LIBTOOL) $(AM_V_lt) --tag=CC $(AM_LIBTOOLFLAGS) \
	$(LIBTOOLFLAGS) --mode=link $(CCLD) $(AM_CFLAGS) $(CFLAGS) \
	$(AM_LDFLAGS) $(LDFLAGS) -o $@
AM_V_CCLD = $(am__v_CCLD_$(V))
am__v_CCLD_ = $(am__v_CCLD_$(AM_DEFAULT_VERBOSITY))
am__v_CCLD_0 = @echo "  CCLD    " $@;
am__v_CCLD_1 = 
SOURCES = $(test_adds_SOURCES) $(test_atoi_strtoi_SOURCES) \
	$(test_chkname_SOURCES) $(test_logind_SOURCES) \
	$(test_sprintf_SOURCES) $(test_strncpy_SOURCES) \
	$(test_strtcpy_SOURCES) $(test_xasprintf_SOURCES) \
	$(test_zustr2stp_SOURCES)
DIST_SOURCES = $(am__test_adds_SOURCES_DIST) \
	$(am__test_atoi_strtoi_SOURCES_DIST) \
	$(am__test_chkname_SOURCES_DIST) \
	$(am__test_logind_SOURCES_DIST) \
	$(am__test_sprintf_SOURCES_DIST) \
	$(am__test_strncpy_SOURCES_DIST) \
	$(am__test_strtcpy_SOURCES_DIST) \
	$(am__test_xasprintf_SOURCES_DIST) \
	$(am__test_zustr2stp_SOURCES_DIST)
am__can_run_installinfo = \
  case $$AM_UPDATE_INFO_DIR in \
    n|no|NO) false;; \
    *) (install-info --version) >/dev/null 2>&1;; \
  esac
am__tagged_files = $(HEADERS) $(SOURCES) $(TAGS_FILES) $(LISP)
# Read a list of newline-separated strings from the standard input,
# and print each of them once, without duplicates.  Input order is
# *not* preserved.
am__uniquify_input = $(AWK) '\
  BEGIN { nonempty = 0; } \
  { items[$$0] = 1; nonempty = 1; } \
  END { if (nonempty) { for (i in items) print i; }; } \
'
# Make sure the list of sources is unique.  This is necessary because,
# e.g., the same source file might be shared among _SOURCES variables
# for different programs/libraries.
am__define_uniq_tagged_files = \
  list='$(am__tagged_files)'; \
  unique=`for i in $$list; do \
    if test -f "$$i"; then echo $$i; else echo $(srcdir)/$$i; fi; \
  done | $(am__uniquify_input)`
am__tty_colors_dummy = \
  mgn= red= grn= lgn= blu= brg= std=; \
  am__color_tests=no
am__tty_colors = { \
  $(am__tty_colors_dummy); \
  if test "X$(AM_COLOR_TESTS)" = Xno; then \
    am__color_tests=no; \
  elif test "X$(AM_COLOR_TESTS)" = Xalways; then \
    am__color_tests=yes; \

=== debian/changelog ===
shadow (1:4.15.2-3.0nosystemd1) nosystemd; urgency=medium

  * No systemd/elogind 

 -- anticapitalista <antix@operamail.com>  Thu, 27 Jun 2024 18:56:48 +0300

shadow (1:4.15.2-3) unstable; urgency=medium

  * d/watch: add versionmangle for -rc
  * Revert "Use upstream's restrictions on user- and group names again".
    Breaks adduser's tests, see #1074306.

 -- Chris Hofstaedtler <zeha@debian.org>  Wed, 26 Jun 2024 12:40:34 +0200

shadow (1:4.15.2-2) unstable; urgency=medium

  * useradd(8): Fix missing paragraph on username length
  * d/rules: explicitly set --with-audit and --enable-subordinate-ids
  * Remove faillog support.
    Stop installing faillog binary and man pages. Stop creating
    /var/log/faillog in login.postinst.
    PAM has removed support for /var/log/faillog by dropping pam_tally, and
    login itself cannot write to it either.
  * Use upstream's restrictions on user- and group names again.
    Upstream started supporting mixed-case names some time ago.
    Purely numeric names (#79682) are now forbidden again, as there is no
    way of distinguishing them from user/group IDs otherwise.
  * Drop useradd's backwards-compatibility -O flag
  * Remove our copy of HOME_MODE.xml, identical upstream
  * shadowconfig.8: actually install again
  * passwd: add Depends: login.
    Stop-gap until passwd can takeover /etc/login.defs from login.

 -- Chris Hofstaedtler <zeha@debian.org>  Tue, 25 Jun 2024 19:42:24 +0200

shadow (1:4.15.2-1) unstable; urgency=medium

  * New upstream version 4.15.2
    Includes fix for csrand_uniform().

 -- Chris Hofstaedtler <zeha@debian.org>  Sat, 22 Jun 2024 17:37:34 +0200

shadow (1:4.15.1-1) unstable; urgency=medium

  * New upstream version 4.15.1
    Closes: #832047, #812127, #1034312, #856902, #791806
    Closes: #1006216, #1006225, #1006208
    * contrib/atudel, non-DFSG-compliant was removed upstream
    * Remove obsolete configure flag --without-libcrack
    * Use functions from libbsd (Closes: #1032393)
    * Build-Depend: libltdl-dev for LT_LIB_DLLOAD
      (Closes: #1065350)
    * Build-Depend: pkgconf
    * Drop upstream applied patches
    * Disable FTMP_FILE by default, drop login failure logging
    * Rebase patch 401_cppw_src.dpatch
    * Rename patch 402_cppw_selinux
    * Use upstream FAILLOG_ENAB code, incompatible with PAM
      (Closes: #776314)
    * Rebase patch 463_login_delay_obeys_to_PAM
    * Rebase patch 501_commonio_group_shadow
    * Rebase patch 502_debian_useradd_defaults
    * Rebase patch 506_relaxed_usernames
    * Rebase patch 542_useradd-O_option
  * Update upstream signing keys
  * Tag build with dh-package-notes
  * Turn off --enable-lastlog, drop lastlog from not-installed
  * Explicitly enable logind on linux-any
  * Update default ENCRYPT_METHOD (Closes: #1043236)
  * login: switch from Essential to Protected: yes (Closes: #960638)
    Moves Pre-Depends to Depends.
  * Enable acl, xattr support (Closes: #745796)
  * login.defs: remove PAM-unsupported crypt settings (Closes: #1055582)

 -- Chris Hofstaedtler <zeha@debian.org>  Sat, 22 Jun 2024 16:08:41 +0200

shadow (1:4.13+dfsg1-5) unstable; urgency=medium

  * Add myself to Uploaders, per discussion with Serge Hallyn
  * Apply wrap-and-sort -kas style
  * Use debputy to avoid Rules-Requires-Root: binary-targets
  * libsubid4: tighten package-internal dependencies

  [ Serge Hallyn ]
  * Drop pam_lastlog.so from config. (Closes: #1068229)
  * Stop installing lastlog binary.

 -- Chris Hofstaedtler <zeha@debian.org>  Sun, 02 Jun 2024 20:01:51 +0200

=== debian/control ===
Source: shadow
Maintainer: Shadow package maintainers <pkg-shadow-devel@lists.alioth.debian.org>
Uploaders:
 Serge Hallyn <serge@hallyn.com>,
 Chris Hofstaedtler <zeha@debian.org>
Section: admin
Priority: required
Build-Depends:
 bison,
 debhelper-compat (= 13),
 dh-package-notes,
 dh-sequence-zz-debputy-rrr (>= 0.1.23~),
 docbook-xml <!nodoc>,
 docbook-xsl <!nodoc>,
 gettext,
 itstool <!nodoc>,
 libacl1-dev,
 libattr1-dev,
 libaudit-dev [linux-any],
 libbsd-dev,
 libcrypt-dev,
 libltdl-dev,
 libpam0g-dev,
 libselinux1-dev [linux-any],
 libsemanage-dev [linux-any],
 libxml2-utils <!nodoc>,
 pkgconf,
 quilt,
 xsltproc <!nodoc>
Standards-Version: 4.6.1
Vcs-Git: https://salsa.debian.org/debian/shadow.git -b master
Vcs-Browser: https://salsa.debian.org/debian/shadow
Homepage: https://github.com/shadow-maint/shadow
Rules-Requires-Root: no

Package: passwd
Architecture: any
Multi-Arch: foreign
Depends:
 libpam-modules
Recommends:
 sensible-utils
Description: change and administer password and group data
 This package includes passwd, chsh, chfn, and many other programs to
 maintain password and group data.
 .
 Shadow passwords are supported.  See /usr/share/doc/passwd/README.Debian

Package: login
Architecture: any
Multi-Arch: foreign
Essential: yes
Depends:
 libpam-modules,
 libpam-runtime
Breaks:
 hurd (<< 20140206~) [hurd-any]
Conflicts:
 python-4suite (<< 0.99cvs20060405-1)
Replaces:
 hurd (<< 20140206~) [hurd-any]
Description: system login tools
 This package provides support for console-based logins and for
 changing effective user or group IDs, including:
  * login, the program that invokes a user shell on a virtual terminal;
  * nologin, a dummy shell for disabled user accounts;

Package: uidmap
Architecture: any
Multi-Arch: foreign
Priority: optional
Description: programs to help use subuids
 These programs help unprivileged users to create uid and gid mappings in
 user namespaces.

Package: libsubid4
Section: libs
Priority: optional
Architecture: any
Multi-Arch: same
Description: subordinate id handling library -- shared library
 The library provides an interface for querying, granding and ungranting
 subordinate user and group ids.

Package: libsubid-dev
Section: libdevel
Priority: optional
Architecture: any
Multi-Arch: same
Depends:
 libsubid4 (= ${binary:Version})
Description: subordinate id handling library -- shared library
 The library provides an interface for querying, granding and ungranting
 subordinate user and group ids.
 .
 This package contains the C header files that are
 needed for applications to use the libsubid4 library.

=== debian/rules ===
#!/usr/bin/make -f
# -*- mode: makefile; coding: utf-8 -*-

# Enable PIE, BINDNOW, and possible future flags.
export DEB_BUILD_MAINT_OPTIONS = hardening=+all
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk
include /usr/share/debhelper/dh_package_notes/package-notes.mk

# Adds extra options when calling the configure script:
DEB_CONFIGURE_EXTRA_FLAGS := \
	--mandir=/usr/share/man \
	--with-libpam \
	--with-yescrypt \
	--enable-shadowgrp \
	--enable-subordinate-ids \
	--enable-lastlog=no \
	--enable-man \
	--disable-account-tools-setuid \
	--with-group-name-max-length=32 \
	--with-acl \
	--with-attr \
	--without-su \
	--without-tcb \


ifneq ($(DEB_HOST_ARCH_OS),linux)
DEB_CONFIGURE_EXTRA_FLAGS += --enable-logind
endif

ifneq ($(filter nodoc,$(DEB_BUILD_PROFILES)),)
DEB_CONFIGURE_EXTRA_FLAGS += --disable-man
endif

DEB_CONFIGURE_EXTRA_FLAGS += SHELL=/bin/sh

# Set the default editor for vipw/vigr
CFLAGS += -DDEFAULT_EDITOR="\"sensible-editor\""

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- $(DEB_CONFIGURE_EXTRA_FLAGS)

override_dh_install-arch:
ifneq ($(DEB_HOST_ARCH_OS),linux)
	sed -i 's/session    optional   pam_keyinit.so/# Linux only # session    optional   pam_keyinit.so/' debian/login.pam
endif
	dh_install -a
ifeq ($(DEB_HOST_ARCH_OS),hurd)
	# /bin/login is provided by the hurd package.
	rm -f debian/login/usr/bin/login
endif

override_dh_installpam:
	# Distribute the pam.d files; unless for the commands with disabled PAM
	# support
	dh_installpam -p login
	dh_installpam -p passwd --name=passwd
	dh_installpam -p passwd --name=chfn
	dh_installpam -p passwd --name=chsh
	dh_installpam -p passwd --name=chpasswd
	dh_installpam -p passwd --name=newusers

override_dh_missing:
	dh_missing --list-missing

override_dh_auto_clean:
	sed -i 's/# Linux only # //' debian/login.pam
	dh_auto_clean

## shadow 4.15.3

=== tests/libsubid/04_nss/Makefile ===
all: test_nss libsubid_zzz.so

BASE_TEST_DIR ?= $(shell git rev-parse --show-toplevel)
basedir := $(BASE_TEST_DIR)

test_nss: test_nss.c $(basedir)/lib/nss.c
	gcc -c -I$(basedir)/lib/ -I$(basedir) -o test_nss.o test_nss.c
	gcc -o test_nss test_nss.o $(basedir)/lib/.libs/libshadow.a -ldl

libsubid_zzz.so: libsubid_zzz.c
	gcc -c -I$(basedir)/lib/ -I$(basedir) -I$(basedir)/libsubid libsubid_zzz.c
	gcc -L$(basedir)/libsubid -shared -o libsubid_zzz.so libsubid_zzz.o $(basedir)/lib/.libs/libshadow.a -ldl

clean:
	rm -f *.o *.so test_nss

=== debian/changelog ===
shadow (1:4.15.3-3ubuntu2) oracular; urgency=medium

  * d/p : disallow pure numeric user and group names (LP: #2076898)

 -- Hector Cao <hector.cao@canonical.com>  Tue, 13 Aug 2024 12:15:06 +0200

shadow (1:4.15.3-3ubuntu1) oracular; urgency=medium

  * Merge with Debian unstable. Remaining changes (LP: #2073338):
    - d/p/* : Enable private home directories by default
    - debian/{source_shadow.py,login.install}: Add apport hook
    - debian/patches/1010_extrausers.patch:
      + Add support to passwd for libnss-extrausers
      + Add automatic detection of "extrausers" for usermod -G
    - d/p/1011_extrausers_toggle.patch: extrausers support for useradd/groupadd
    - d/p/1012_extrausers_chfn.patch: --extrausers support for chfn tool
      This patch has been refreshed to remove "implicit function declaration"
      warning
    - d/p/1013_extrausers_deluser.patch: --extrausers support for userdel
    - d/p/1014_extrausers_delgroup.patch: --extrausers support for groupdel
      This patch has been refreshed to remove "implicit function declaration"
      warning
    - d/p/1015_add_zsys_support.patch: zsys to handle home dir if available
    - d/p/1016_extrausers_gpasswd.patch: extrausers support for gpasswd
    - d/p/506_relaxed_usernames.patch, d/t/{control,numeric-username}:
      + disallow purely numeric usernames
        The patch has been integrated in debian but we still have to
        keep the tests
    - d/t/smoke: Extend for extrausers support
    - Add some cursory tests for the extrausers features
    - d/p/lp2063200: fix useradd group validation with extrausers (LP 2063200)

    Dropped changes:
    - debian/login.defs: Update documentation of USERGROUPS_ENAB/UMASK
      Reason: Integrated upstream
    - Fix ftbfs with -Werror=implicit-function-declaration
      Reason: Integrated upstream

 -- Hector Cao <hector.cao@canonical.com>  Mon, 29 Jul 2024 11:30:50 +0200

shadow (1:4.15.3-3) unstable; urgency=medium

  * Forbid backslashes in user/group-names.
    They can still be used with --force-badname, but it's a start. In the
    long run I want to remove our relax patch, and upstream should fix the
    line continuation too. For #1076619.

 -- Chris Hofstaedtler <zeha@debian.org>  Sun, 21 Jul 2024 21:05:32 +0200

shadow (1:4.15.3-2) unstable; urgency=medium

  [ Pino Toscano ]
  * d/rules: actually enable Linux-only options on Linux
    This enables --enable-logind and --with-audit.

  [ Chris Hofstaedtler ]
  * Stop installing groupmems(8) (Closes: #1004472, LP: #2039541)
  * login.defs: remove obsolete/confusing comments
  * login.defs: resync comments with upstream
  * login.defs: remove incomplete list of unused vars
  * login.defs: remove obscure, defaulted vars
  * login.defs: remove vars ignored by su(1)
  * login.defs: remove CONSOLE_GROUPS, ignored with PAM
  * login.defs: remove CONSOLE, ignored with PAM

 -- Chris Hofstaedtler <zeha@debian.org>  Sun, 07 Jul 2024 15:30:38 +0200

shadow (1:4.15.3-1) unstable; urgency=medium

  * New upstream version 4.15.3
  * tests: follow upstream subdir fix
  * Fix setup of test libsubid-04_nss
  * Drop login.postinst, obsoleted by #1074121
  * Bump Standards-Version to 4.7.0

 -- Chris Hofstaedtler <zeha@debian.org>  Sat, 06 Jul 2024 23:50:36 +0200

shadow (1:4.13+dfsg1-4ubuntu5) oracular; urgency=medium

  * d/p/lp2063200/*: amend the patch to fix `useradd -D` breakage
    (LP: #2063200)

 -- Simon Chopin <schopin@ubuntu.com>  Mon, 27 May 2024 18:56:51 +0200

shadow (1:4.13+dfsg1-4ubuntu4) oracular; urgency=medium

  * Add some cursory tests for the extrausers features
  * d/p/lp2063200: fix useradd group validation with extrausers (LP: 2063200)

 -- Simon Chopin <schopin@ubuntu.com>  Tue, 07 May 2024 18:49:58 +0200

=== debian/control ===
--- 
+++ 
@@ -1,5 +1,6 @@
 Source: shadow
-Maintainer: Shadow package maintainers <pkg-shadow-devel@lists.alioth.debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Shadow package maintainers <pkg-shadow-devel@lists.alioth.debian.org>
 Uploaders:
  Serge Hallyn <serge@hallyn.com>,
  Chris Hofstaedtler <zeha@debian.org>
@@ -23,11 +24,13 @@
  libpam0g-dev,
  libselinux1-dev [linux-any],
  libsemanage-dev [linux-any],
+ libsystemd-dev [linux-any],
  libxml2-utils <!nodoc>,
  pkgconf,
  quilt,
+ systemd-dev [linux-any],
  xsltproc <!nodoc>
-Standards-Version: 4.6.1
+Standards-Version: 4.7.0
 Vcs-Git: https://salsa.debian.org/debian/shadow.git -b master
 Vcs-Browser: https://salsa.debian.org/debian/shadow
 Homepage: https://github.com/shadow-maint/shadow
@@ -37,7 +40,9 @@
 Architecture: any
 Multi-Arch: foreign
 Depends:
- libpam-modules
+ base-passwd (>= 3.6.4),
+ libpam-modules,
+ login
 Recommends:
  sensible-utils
 Description: change and administer password and group data
@@ -49,7 +54,7 @@
 Package: login
 Architecture: any
 Multi-Arch: foreign
-Essential: yes
+Protected: yes
 Depends:
  libpam-modules,
  libpam-runtime

=== debian/rules ===
--- 
+++ 
@@ -24,8 +24,9 @@
 	--without-tcb \
 
 
-ifneq ($(DEB_HOST_ARCH_OS),linux)
+ifeq ($(DEB_HOST_ARCH_OS),linux)
 DEB_CONFIGURE_EXTRA_FLAGS += --enable-logind
+DEB_CONFIGURE_EXTRA_FLAGS += --with-audit
 endif
 
 ifneq ($(filter nodoc,$(DEB_BUILD_PROFILES)),)
@@ -63,9 +64,6 @@
 	dh_installpam -p passwd --name=chpasswd
 	dh_installpam -p passwd --name=newusers
 
-override_dh_missing:
-	dh_missing --list-missing
-
 override_dh_auto_clean:
 	sed -i 's/# Linux only # //' debian/login.pam
 	dh_auto_clean

## shadow 4.16.0

=== tests/tests/unit/Makefile ===
--- 
+++ 
@@ -87,14 +87,14 @@
 POST_UNINSTALL = :
 build_triplet = x86_64-pc-linux-gnu
 host_triplet = x86_64-pc-linux-gnu
-check_PROGRAMS = test_adds$(EXEEXT) \
-	test_atoi_strtoi$(EXEEXT) \
-	test_chkname$(EXEEXT) test_sprintf$(EXEEXT) \
-	test_strncpy$(EXEEXT) test_strtcpy$(EXEEXT) \
-	test_xasprintf$(EXEEXT) \
-	test_zustr2stp$(EXEEXT) $(am__EXEEXT_1)
-am__append_1 = \
-    test_logind
+#check_PROGRAMS = test_adds$(EXEEXT) \
+#	test_atoi_strtoi$(EXEEXT) \
+#	test_chkname$(EXEEXT) test_sprintf$(EXEEXT) \
+#	test_strncpy$(EXEEXT) test_strtcpy$(EXEEXT) \
+#	test_xasprintf$(EXEEXT) \
+#	test_zustr2stp$(EXEEXT) $(am__EXEEXT_1)
+#am__append_1 = \
+#    test_logind
 
 subdir = tests/unit
 ACLOCAL_M4 = $(top_srcdir)/aclocal.m4
@@ -114,16 +114,16 @@
 CONFIG_HEADER = $(top_builddir)/config.h
 CONFIG_CLEAN_FILES =
 CONFIG_CLEAN_VPATH_FILES =
-am__EXEEXT_1 =  \
-	test_logind$(EXEEXT)
+#am__EXEEXT_1 =  \
+#	test_logind$(EXEEXT)
 am__test_adds_SOURCES_DIST = ../../lib/adds.c test_adds.c
 am__dirstamp = $(am__leading_dot)dirstamp
-am_test_adds_OBJECTS =  \
-	../../lib/test_adds-adds.$(OBJEXT) \
-	test_adds-test_adds.$(OBJEXT)
+#am_test_adds_OBJECTS =  \
+#	../../lib/test_adds-adds.$(OBJEXT) \
+#	test_adds-test_adds.$(OBJEXT)
 test_adds_OBJECTS = $(am_test_adds_OBJECTS)
 am__DEPENDENCIES_1 =
-test_adds_DEPENDENCIES = $(am__DEPENDENCIES_1)
+#test_adds_DEPENDENCIES = $(am__DEPENDENCIES_1)
 AM_V_lt = $(am__v_lt_$(V))
 am__v_lt_ = $(am__v_lt_$(AM_DEFAULT_VERBOSITY))
 am__v_lt_0 = --silent
@@ -133,75 +133,75 @@
 	$(CFLAGS) $(test_adds_LDFLAGS) $(LDFLAGS) -o $@
 am__test_atoi_strtoi_SOURCES_DIST = ../../lib/atoi/strtoi.c \
 	test_atoi_strtoi.c
-am_test_atoi_strtoi_OBJECTS = ../../lib/atoi/test_atoi_strtoi-strtoi.$(OBJEXT) \
-	test_atoi_strtoi-test_atoi_strtoi.$(OBJEXT)
+#am_test_atoi_strtoi_OBJECTS = ../../lib/atoi/test_atoi_strtoi-strtoi.$(OBJEXT) \
+#	test_atoi_strtoi-test_atoi_strtoi.$(OBJEXT)
 test_atoi_strtoi_OBJECTS = $(am_test_atoi_strtoi_OBJECTS)
-test_atoi_strtoi_DEPENDENCIES =  \
-	$(am__DEPENDENCIES_1)
+#test_atoi_strtoi_DEPENDENCIES =  \
+#	$(am__DEPENDENCIES_1)
 test_atoi_strtoi_LINK = $(LIBTOOL) $(AM_V_lt) --tag=CC \
 	$(AM_LIBTOOLFLAGS) $(LIBTOOLFLAGS) --mode=link $(CCLD) \
 	$(test_atoi_strtoi_CFLAGS) $(CFLAGS) \
 	$(test_atoi_strtoi_LDFLAGS) $(LDFLAGS) -o $@
 am__test_chkname_SOURCES_DIST = ../../lib/chkname.c test_chkname.c
-am_test_chkname_OBJECTS =  \
-	../../lib/test_chkname-chkname.$(OBJEXT) \
-	test_chkname-test_chkname.$(OBJEXT)
+#am_test_chkname_OBJECTS =  \
+#	../../lib/test_chkname-chkname.$(OBJEXT) \
+#	test_chkname-test_chkname.$(OBJEXT)
 test_chkname_OBJECTS = $(am_test_chkname_OBJECTS)
-test_chkname_DEPENDENCIES = $(am__DEPENDENCIES_1)
+#test_chkname_DEPENDENCIES = $(am__DEPENDENCIES_1)
 test_chkname_LINK = $(LIBTOOL) $(AM_V_lt) --tag=CC $(AM_LIBTOOLFLAGS) \
 	$(LIBTOOLFLAGS) --mode=link $(CCLD) $(test_chkname_CFLAGS) \
 	$(CFLAGS) $(test_chkname_LDFLAGS) $(LDFLAGS) -o $@
 am__test_logind_SOURCES_DIST = ../../lib/logind.c test_logind.c
-am_test_logind_OBJECTS =  \
-	../../lib/test_logind-logind.$(OBJEXT) \
-	test_logind-test_logind.$(OBJEXT)
+#am_test_logind_OBJECTS =  \
+#	../../lib/test_logind-logind.$(OBJEXT) \
+#	test_logind-test_logind.$(OBJEXT)
 test_logind_OBJECTS = $(am_test_logind_OBJECTS)
-test_logind_DEPENDENCIES = $(am__DEPENDENCIES_1) \
-	$(am__DEPENDENCIES_1)
+#test_logind_DEPENDENCIES = $(am__DEPENDENCIES_1) \
+#	$(am__DEPENDENCIES_1)
 test_logind_LINK = $(LIBTOOL) $(AM_V_lt) --tag=CC $(AM_LIBTOOLFLAGS) \
 	$(LIBTOOLFLAGS) --mode=link $(CCLD) $(test_logind_CFLAGS) \
 	$(CFLAGS) $(test_logind_LDFLAGS) $(LDFLAGS) -o $@
 am__test_sprintf_SOURCES_DIST = ../../lib/string/sprintf.c \
 	test_sprintf.c
-am_test_sprintf_OBJECTS = ../../lib/string/test_sprintf-sprintf.$(OBJEXT) \
-	test_sprintf-test_sprintf.$(OBJEXT)
+#am_test_sprintf_OBJECTS = ../../lib/string/test_sprintf-sprintf.$(OBJEXT) \
+#	test_sprintf-test_sprintf.$(OBJEXT)
 test_sprintf_OBJECTS = $(am_test_sprintf_OBJECTS)
-test_sprintf_DEPENDENCIES = $(am__DEPENDENCIES_1)
+#test_sprintf_DEPENDENCIES = $(am__DEPENDENCIES_1)
 test_sprintf_LINK = $(LIBTOOL) $(AM_V_lt) --tag=CC $(AM_LIBTOOLFLAGS) \
 	$(LIBTOOLFLAGS) --mode=link $(CCLD) $(test_sprintf_CFLAGS) \
 	$(CFLAGS) $(test_sprintf_LDFLAGS) $(LDFLAGS) -o $@
 am__test_strncpy_SOURCES_DIST = test_strncpy.c
-am_test_strncpy_OBJECTS =  \
-	test_strncpy-test_strncpy.$(OBJEXT)
+#am_test_strncpy_OBJECTS =  \
+#	test_strncpy-test_strncpy.$(OBJEXT)
 test_strncpy_OBJECTS = $(am_test_strncpy_OBJECTS)
-test_strncpy_DEPENDENCIES = $(am__DEPENDENCIES_1)
+#test_strncpy_DEPENDENCIES = $(am__DEPENDENCIES_1)
 test_strncpy_LINK = $(LIBTOOL) $(AM_V_lt) --tag=CC $(AM_LIBTOOLFLAGS) \
 	$(LIBTOOLFLAGS) --mode=link $(CCLD) $(test_strncpy_CFLAGS) \
 	$(CFLAGS) $(test_strncpy_LDFLAGS) $(LDFLAGS) -o $@
 am__test_strtcpy_SOURCES_DIST = ../../lib/string/strtcpy.c \
 	test_strtcpy.c
-am_test_strtcpy_OBJECTS = ../../lib/string/test_strtcpy-strtcpy.$(OBJEXT) \
-	test_strtcpy-test_strtcpy.$(OBJEXT)
+#am_test_strtcpy_OBJECTS = ../../lib/string/test_strtcpy-strtcpy.$(OBJEXT) \
+#	test_strtcpy-test_strtcpy.$(OBJEXT)
 test_strtcpy_OBJECTS = $(am_test_strtcpy_OBJECTS)
-test_strtcpy_DEPENDENCIES = $(am__DEPENDENCIES_1)
+#test_strtcpy_DEPENDENCIES = $(am__DEPENDENCIES_1)
 test_strtcpy_LINK = $(LIBTOOL) $(AM_V_lt) --tag=CC $(AM_LIBTOOLFLAGS) \
 	$(LIBTOOLFLAGS) --mode=link $(CCLD) $(test_strtcpy_CFLAGS) \
 	$(CFLAGS) $(test_strtcpy_LDFLAGS) $(LDFLAGS) -o $@
 am__test_xasprintf_SOURCES_DIST = ../../lib/string/sprintf.c \
 	test_xasprintf.c
-am_test_xasprintf_OBJECTS = ../../lib/string/test_xasprintf-sprintf.$(OBJEXT) \
-	test_xasprintf-test_xasprintf.$(OBJEXT)
+#am_test_xasprintf_OBJECTS = ../../lib/string/test_xasprintf-sprintf.$(OBJEXT) \
+#	test_xasprintf-test_xasprintf.$(OBJEXT)
 test_xasprintf_OBJECTS = $(am_test_xasprintf_OBJECTS)
-test_xasprintf_DEPENDENCIES = $(am__DEPENDENCIES_1)
+#test_xasprintf_DEPENDENCIES = $(am__DEPENDENCIES_1)
 test_xasprintf_LINK = $(LIBTOOL) $(AM_V_lt) --tag=CC \
 	$(AM_LIBTOOLFLAGS) $(LIBTOOLFLAGS) --mode=link $(CCLD) \
 	$(test_xasprintf_CFLAGS) $(CFLAGS) $(test_xasprintf_LDFLAGS) \
 	$(LDFLAGS) -o $@
 am__test_zustr2stp_SOURCES_DIST = test_zustr2stp.c
-am_test_zustr2stp_OBJECTS =  \
-	test_zustr2stp-test_zustr2stp.$(OBJEXT)
+#am_test_zustr2stp_OBJECTS =  \
+#	test_zustr2stp-test_zustr2stp.$(OBJEXT)
 test_zustr2stp_OBJECTS = $(am_test_zustr2stp_OBJECTS)
-test_zustr2stp_DEPENDENCIES = $(am__DEPENDENCIES_1)
+#test_zustr2stp_DEPENDENCIES = $(am__DEPENDENCIES_1)
 test_zustr2stp_LINK = $(LIBTOOL) $(AM_V_lt) --tag=CC \
 	$(AM_LIBTOOLFLAGS) $(LIBTOOLFLAGS) --mode=link $(CCLD) \
 	$(test_zustr2stp_CFLAGS) $(CFLAGS) $(test_zustr2stp_LDFLAGS) \
@@ -299,5 +299,3 @@
   $(am__tty_colors_dummy); \
   if test "X$(AM_COLOR_TESTS)" = Xno; then \
     am__color_tests=no; \
-  elif test "X$(AM_COLOR_TESTS)" = Xalways; then \
-    am__color_tests=yes; \

=== tests/tests/libsubid/04_nss/Makefile ===
all: test_nss libsubid_zzz.so

test_nss: test_nss.c ../../../lib/nss.c
	gcc -c -I../../../lib/ -I../../.. -o test_nss.o test_nss.c
	gcc -o test_nss test_nss.o ../../../lib/.libs/libshadow.a -ldl

libsubid_zzz.so: libsubid_zzz.c
	gcc -c -I../../../lib/ -I../../.. -I../../../libsubid libsubid_zzz.c
	gcc -L../../../libsubid -shared -o libsubid_zzz.so libsubid_zzz.o ../../../lib/.libs/libshadow.a -ldl

clean:
	rm -f *.o *.so test_nss

=== debian/changelog ===
shadow (1:4.16.0-7ubuntu1) plucky; urgency=medium

  * Merge with Debian unstable. Remaining changes (LP: #2089923):
    - d/p/* : Enable private home directories by default
    - debian/{source_shadow.py,login.defs.install}: Add apport hook
    - debian/patches/1010_extrausers.patch:
      + Add support to passwd for libnss-extrausers
      + Add automatic detection of "extrausers" for usermod -G
    - d/p/1011_extrausers_toggle.patch: extrausers support for useradd/groupadd
    - d/p/1012_extrausers_chfn.patch: --extrausers support for chfn tool
    - d/p/1013_extrausers_deluser.patch: --extrausers support for userdel
    - d/p/1014_extrausers_delgroup.patch: --extrausers support for groupdel
    - d/p/1016_extrausers_gpasswd.patch: extrausers support for gpasswd
    - d/p/506_relaxed_usernames.patch, d/t/{control,numeric-username}:
    - d/t/smoke: Extend for extrausers support
    - Add some cursory tests for the extrausers features
    - d/p/lp2063200: fix useradd group validation with extrausers (LP 2063200)

  * New Changes:
    - d/tests: make 'upstream' tests work with current sources layout

  * Drop Changes:
    - d/p/1015_add_zsys_support.patch: zsys to handle home dir if available
      Reason: buggy and unmaintained zsys integration (LP: #2049529)

 -- Florent 'Skia' Jacquet <florent.jacquet@canonical.com>  Mon, 02 Dec 2024 12:39:54 +0100

shadow (1:4.16.0-7) unstable; urgency=medium

  [ Florent 'Skia' Jacquet ]
  * d/patches: fix 'upstream' test suite

 -- Chris Hofstaedtler <zeha@debian.org>  Fri, 06 Dec 2024 13:51:40 +0100

shadow (1:4.16.0-6) unstable; urgency=medium

  * Add NEWS entry about faillog (Closes: #1074320)

 -- Chris Hofstaedtler <zeha@debian.org>  Fri, 06 Dec 2024 13:29:54 +0100

shadow (1:4.16.0-5) unstable; urgency=medium

  [ Chris Hofstaedtler ]
  * Always build with btrfs support on linux-any (Closes: #856557)
  * debputy.manifest: merge path-metadata entries
  * login.defs: remove info about write(1)
    Which is not part of Debian trixie. (Closes: #1087519)

  [ Pino Toscano ]
  * Include <utmpx.h>, fixing the build on GNU/Hurd

 -- Chris Hofstaedtler <zeha@debian.org>  Fri, 15 Nov 2024 20:30:32 +0100

shadow (1:4.16.0-4) unstable; urgency=medium

  * Drop Debian-only cppw, cpgr tools (Closes: #750752)
  * Stop patching login, not installed anymore
  * Define LOGIN_NAME_MAX on HURD
  * Remove libsystemd-dev Build-Depends.
    Only necessary for login(1).
  * Stop building programs we do not install

 -- Chris Hofstaedtler <zeha@debian.org>  Tue, 06 Aug 2024 00:29:18 +0200

shadow (1:4.16.0-3) unstable; urgency=medium

  * Upload to unstable.
  * Fix FTBFS on hurd.
    DEB_HOST_ARCH_OS was unset.

 -- Chris Hofstaedtler <zeha@debian.org>  Mon, 05 Aug 2024 17:21:27 +0200

shadow (1:4.16.0-2) experimental; urgency=medium

  * passwd: switch Depends from login to login.defs
    login will again be installed on fewer systems, but existing installs
    will retain it (it is Protected: yes).
  * Drop login package, to allow takeover by util-linux.
    Move shadow.mo to Package: passwd, have passwd Replaces: older login.
  * login.defs: ship manpage
  * Re-add workarounds for tests in tests/tests directory.
    4.15.3 fixed this, but 4.16.0 happened earlier.

 -- Chris Hofstaedtler <zeha@debian.org>  Mon, 05 Aug 2024 02:36:29 +0200

shadow (1:4.16.0-1) experimental; urgency=medium

  * New upstream version 4.16.0
    * Rebase patches
  * Split /etc/login.defs into its own binary package (Closes: #1074394)
  * Rename libsubid4 to libsubid5 (soname bump)
  * d/watch: add versionmangle for -rc

 -- Chris Hofstaedtler <zeha@debian.org>  Fri, 02 Aug 2024 17:35:29 +0200

=== debian/control ===
--- 
+++ 
@@ -24,7 +24,6 @@
  libpam0g-dev,
  libselinux1-dev [linux-any],
  libsemanage-dev [linux-any],
- libsystemd-dev [linux-any],
  libxml2-utils <!nodoc>,
  pkgconf,
  quilt,
@@ -42,33 +41,25 @@
 Depends:
  base-passwd (>= 3.6.4),
  libpam-modules,
- login
+ login.defs
 Recommends:
  sensible-utils
+Replaces:
+ login (<< 1:4.16.0-2~)
 Description: change and administer password and group data
  This package includes passwd, chsh, chfn, and many other programs to
  maintain password and group data.
  .
  Shadow passwords are supported.  See /usr/share/doc/passwd/README.Debian
 
-Package: login
-Architecture: any
+Package: login.defs
+Architecture: all
 Multi-Arch: foreign
-Protected: yes
-Depends:
- libpam-modules,
- libpam-runtime
-Breaks:
- hurd (<< 20140206~) [hurd-any]
-Conflicts:
- python-4suite (<< 0.99cvs20060405-1)
 Replaces:
- hurd (<< 20140206~) [hurd-any]
-Description: system login tools
- This package provides support for console-based logins and for
- changing effective user or group IDs, including:
-  * login, the program that invokes a user shell on a virtual terminal;
-  * nologin, a dummy shell for disabled user accounts;
+ login (<< 1:4.16.0-2~)
+Description: system user management configuration
+ This package provides the login.defs configuration file,
+ used by otherwise unrelated tools managing system users.
 
 Package: uidmap
 Architecture: any
@@ -78,7 +69,7 @@
  These programs help unprivileged users to create uid and gid mappings in
  user namespaces.
 
-Package: libsubid4
+Package: libsubid5
 Section: libs
 Priority: optional
 Architecture: any
@@ -93,10 +84,10 @@
 Architecture: any
 Multi-Arch: same
 Depends:
- libsubid4 (= ${binary:Version})
+ libsubid5 (= ${binary:Version})
 Description: subordinate id handling library -- shared library
  The library provides an interface for querying, granding and ungranting
  subordinate user and group ids.
  .
  This package contains the C header files that are
- needed for applications to use the libsubid4 library.
+ needed for applications to use the libsubid library.

=== debian/rules ===
--- 
+++ 
@@ -4,6 +4,7 @@
 # Enable PIE, BINDNOW, and possible future flags.
 export DEB_BUILD_MAINT_OPTIONS = hardening=+all
 DPKG_EXPORT_BUILDFLAGS = 1
+include /usr/share/dpkg/architecture.mk
 include /usr/share/dpkg/buildflags.mk
 include /usr/share/debhelper/dh_package_notes/package-notes.mk
 
@@ -25,8 +26,8 @@
 
 
 ifeq ($(DEB_HOST_ARCH_OS),linux)
-DEB_CONFIGURE_EXTRA_FLAGS += --enable-logind
 DEB_CONFIGURE_EXTRA_FLAGS += --with-audit
+DEB_CONFIGURE_EXTRA_FLAGS += --with-btrfs
 endif
 
 ifneq ($(filter nodoc,$(DEB_BUILD_PROFILES)),)
@@ -44,26 +45,12 @@
 override_dh_auto_configure:
 	dh_auto_configure -- $(DEB_CONFIGURE_EXTRA_FLAGS)
 
-override_dh_install-arch:
-ifneq ($(DEB_HOST_ARCH_OS),linux)
-	sed -i 's/session    optional   pam_keyinit.so/# Linux only # session    optional   pam_keyinit.so/' debian/login.pam
-endif
-	dh_install -a
-ifeq ($(DEB_HOST_ARCH_OS),hurd)
-	# /bin/login is provided by the hurd package.
-	rm -f debian/login/usr/bin/login
-endif
-
 override_dh_installpam:
 	# Distribute the pam.d files; unless for the commands with disabled PAM
 	# support
-	dh_installpam -p login
 	dh_installpam -p passwd --name=passwd
 	dh_installpam -p passwd --name=chfn
 	dh_installpam -p passwd --name=chsh
 	dh_installpam -p passwd --name=chpasswd
 	dh_installpam -p passwd --name=newusers
 
-override_dh_auto_clean:
-	sed -i 's/# Linux only # //' debian/login.pam
-	dh_auto_clean

=== debian/tests/control ===
Tests: smoke
Restrictions: needs-root, superficial

Tests: upstream
Depends:
 expect,
 procps,
 @,
 @builddeps@
Restrictions: needs-root, build-needed, breaks-testbed, allow-stderr, isolation-machine

Tests: numeric-username
Restrictions: needs-root, allow-stderr

Tests: extrausers-etc-readonly
Restrictions: needs-root, allow-stderr, breaks-testbed
Depends: passwd, libnss-extrausers, augeas-tools

## shadow 4.17.2

=== debian/changelog ===
shadow (1:4.17.2-5) unstable; urgency=medium

  * Warn about future --badname removal.
    Upstream PR 1158 plans to remove this flag, probably in the forky
    timeframe. Warn users now.
  * Import upstream patch to fix chfn (#1096187)
  * Add regression test for #1096187
  * Add regression test for #1095430
  * Remove "shadowconfig off"
    If needed please run pwunconv, grpunconv manually, but please understand
    you are on your own.

 -- Chris Hofstaedtler <zeha@debian.org>  Mon, 17 Feb 2025 19:54:09 +0100

shadow (1:4.17.2-4) unstable; urgency=medium

  * Revert upstreams chfn.c strsep change (Closes: #1096187)

 -- Chris Hofstaedtler <zeha@debian.org>  Mon, 17 Feb 2025 12:28:56 +0100

shadow (1:4.17.2-3) unstable; urgency=medium

  * Revert upstreams strtoday calculation "fix" (Closes: #1095430)

 -- Chris Hofstaedtler <zeha@debian.org>  Sun, 16 Feb 2025 20:24:35 +0100

shadow (1:4.17.2-2) unstable; urgency=medium

  * Upload to unstable.
  * Apply upstream revert of "Use local time for human-readable dates"
    (Closes: #1095430)

 -- Chris Hofstaedtler <zeha@debian.org>  Sat, 15 Feb 2025 17:21:17 +0100

shadow (1:4.17.2-1) experimental; urgency=medium

  * New upstream version 4.17.2
  * Apply upstream patch from Marc Haber to document E_BAD_NAME
  * Refresh patches

 -- Chris Hofstaedtler <zeha@debian.org>  Sun, 09 Feb 2025 18:14:51 +0100

shadow (1:4.17.1-2) experimental; urgency=medium

  * Rewrite shadowconfig(8) manpage.
    Thanks to Alejandro Colomar <alx@kernel.org>
  * Remove unnecessary Build-Depends: quilt.
    Thanks to Bastian Germann (Closes: #1092461)

 -- Chris Hofstaedtler <zeha@debian.org>  Wed, 08 Jan 2025 12:40:10 +0100

shadow (1:4.17.1-1) experimental; urgency=medium

  * New upstream version 4.17.1

 -- Chris Hofstaedtler <zeha@debian.org>  Sat, 04 Jan 2025 12:41:51 +0100

shadow (1:4.17.0-1) experimental; urgency=medium

  * New upstream version 4.17.0
  * Refresh patches.

 -- Chris Hofstaedtler <zeha@debian.org>  Sat, 28 Dec 2024 13:14:16 +0100

shadow (1:4.17.0~rc1-2) experimental; urgency=medium

  * Remove Debian patch to relax username checks.
    Per discussion on d-devel, with upstream, and with the
    adduser maintainer.
    Thanks: Marc Haber

 -- Chris Hofstaedtler <zeha@debian.org>  Sun, 22 Dec 2024 20:15:16 +0100

shadow (1:4.17.0~rc1-1) experimental; urgency=medium

  * New upstream version 4.17.0~rc1
  * Add upstream patch for new return-code for bad usernames
  * Refresh patches
  * d/copyright: update
  * Forbid purely numeric user/group names, and "." and ".."

 -- Chris Hofstaedtler <zeha@debian.org>  Fri, 06 Dec 2024 19:55:32 +0100

## shadow 4.17.3

=== debian/changelog ===
shadow (1:4.17.3-3.0nosystemd1) nosystemd; urgency=medium

  * No systemd/elogind 

 -- anticapitalista <antix@operamail.com>  Tue, 01 Apr 2025 22:40:22 +0300

shadow (1:4.17.3-3) unstable; urgency=medium

  * Accept /usr/sbin/nologin as an alternate to /sbin/nologin.
    Thanks to Marc Haber

 -- Chris Hofstaedtler <zeha@debian.org>  Fri, 28 Mar 2025 12:13:03 +0100

shadow (1:4.17.3-2) unstable; urgency=medium

  * Do not warn about useradd --system with Debian-globally allocated uids
    (Closes: #1100563)
  * Refresh patches

 -- Chris Hofstaedtler <zeha@debian.org>  Sun, 16 Mar 2025 13:39:58 +0100

shadow (1:4.17.3-1) unstable; urgency=medium

  * New upstream version 4.17.3
  * Refresh patches and include upstream patch for getdate.
    Include https://github.com/shadow-maint/shadow/pull/1214 to fix
    https://bugs.debian.org/cgi-bin/bugreport.cgi?bug=1095430 in the
    way upstream intends to fix it.
  * Explicitly pass {s,}bindir to configure.
    Avoids upstream hacks in configure.

 -- Chris Hofstaedtler <zeha@debian.org>  Mon, 24 Feb 2025 23:09:52 +0100

shadow (1:4.17.2-6) unstable; urgency=medium

  * d/rules: ensure lib/getdate.c gets rebuilt
  * configure: always pick /usr/bin/passwd.
    Thanks to Jochen Sprickerhof <jspricke@debian.org>

 -- Chris Hofstaedtler <zeha@debian.org>  Mon, 24 Feb 2025 12:16:49 +0100

=== debian/control ===
--- 
+++ 
@@ -1,6 +1,5 @@
 Source: shadow
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Shadow package maintainers <pkg-shadow-devel@lists.alioth.debian.org>
+Maintainer: Shadow package maintainers <pkg-shadow-devel@lists.alioth.debian.org>
 Uploaders:
  Serge Hallyn <serge@hallyn.com>,
  Chris Hofstaedtler <zeha@debian.org>
@@ -26,8 +25,6 @@
  libsemanage-dev [linux-any],
  libxml2-utils <!nodoc>,
  pkgconf,
- quilt,
- systemd-dev [linux-any],
  xsltproc <!nodoc>
 Standards-Version: 4.7.0
 Vcs-Git: https://salsa.debian.org/debian/shadow.git -b master

=== debian/rules ===
--- 
+++ 
@@ -10,6 +10,8 @@
 
 # Adds extra options when calling the configure script:
 DEB_CONFIGURE_EXTRA_FLAGS := \
+	--bindir=/usr/bin \
+	--sbindir=/usr/sbin \
 	--mandir=/usr/share/man \
 	--with-libpam \
 	--with-yescrypt \
@@ -42,6 +44,10 @@
 %:
 	dh $@
 
+execute_after_dh_auto_clean:
+	# rebuild lib/getdate.c
+	rm -f lib/getdate.c
+
 override_dh_auto_configure:
 	dh_auto_configure -- $(DEB_CONFIGURE_EXTRA_FLAGS)
 
@@ -54,3 +60,5 @@
 	dh_installpam -p passwd --name=chpasswd
 	dh_installpam -p passwd --name=newusers
 
+override_dh_missing:
+	dh_missing --list-missing
